#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0
#define MAXSIZE 20 /* 洢ռʼ */

typedef int Status; 

typedef int SElemType; /* SElemType͸ʵΪint */


/* ջռṹ */
typedef struct 
{
        SElemType data[MAXSIZE];
        int top1;	/* ջ1ջָ */
        int top2;	/* ջ2ջָ */
}SqDoubleStack;


Status visit(SElemType c)
{
        printf("%d ",c);
        return OK;
}

/*  һջS */
Status InitStack(SqDoubleStack *S)
{ 
        S->top1=-1;
        S->top2=MAXSIZE;
        return OK;
}

/* SΪջ */
Status ClearStack(SqDoubleStack *S)
{ 
        S->top1=-1;
        S->top2=MAXSIZE;
        return OK;
}

/* ջSΪջ򷵻TRUE򷵻FALSE */
Status StackEmpty(SqDoubleStack S)
{ 
        if (S.top1==-1 && S.top2==MAXSIZE)
                return TRUE;
        else
                return FALSE;
}

/* SԪظջĳ */
int StackLength(SqDoubleStack S)
{ 
        return (S.top1+1)+(MAXSIZE-S.top2);
}

/* ԪeΪµջԪ */
Status Push(SqDoubleStack *S,SElemType e,int stackNumber)
{
        if (S->top1+1==S->top2)	/* ջpushԪ */
                return ERROR;	
        if (stackNumber==1)			/* ջ1Ԫؽջ */
                S->data[++S->top1]=e; /* ջ1top1+1Ԫظֵ */
        else if (stackNumber==2)	/* ջ2Ԫؽջ */
                S->data[--S->top2]=e; /* ջ2top2-1Ԫظֵ */
        return OK;
}

/* ջգɾSջԪأeֵOK򷵻ERROR */
Status Pop(SqDoubleStack *S,SElemType *e,int stackNumber)
{ 
        if (stackNumber==1) 
        {
                if (S->top1==-1) 
                        return ERROR; /* ˵ջ1Ѿǿջ */
                *e=S->data[S->top1--]; /* ջ1ջԪسջ */
        }
        else if (stackNumber==2)
        { 
                if (S->top2==MAXSIZE) 
                        return ERROR; /* ˵ջ2Ѿǿջ */
                *e=S->data[S->top2++]; /* ջ2ջԪسջ */
        }
        return OK;
}

Status StackTraverse(SqDoubleStack S)
{
        int i;
        i=0;
        while(i<=S.top1)
        {
                visit(S.data[i++]);
        }
        i=S.top2;
        while(i<MAXSIZE)
        {
                visit(S.data[i++]);
        }
        printf("\n");
        return OK;
}

int main()
{
        int j;
        SqDoubleStack s;
        int e;
        if(InitStack(&s)==OK)
        {
                for(j=1;j<=5;j++)
                        Push(&s,j,1);
                for(j=MAXSIZE;j>=MAXSIZE-2;j--)
                        Push(&s,j,2);
        }

        printf("ջԪΪ");
        StackTraverse(s);

        printf("ǰջԪУ%d \n",StackLength(s));

        Pop(&s,&e,2);
        printf("ջԪ e=%d\n",e);
        printf("ջշ%d(1: 0:)\n",StackEmpty(s));

        for(j=6;j<=MAXSIZE-2;j++)
                Push(&s,j,1);

        printf("ջԪΪ");
        StackTraverse(s);

        printf("ջ%d(1: 0:)\n",Push(&s,100,1));

        
        ClearStack(&s);
        printf("ջջշ%d(1: 0:)\n",StackEmpty(s));
        
        return 0;
}