#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0
#define MAXSIZE 20 /* 洢ռʼ */

typedef int Status; 
typedef int SElemType; /* SElemType͸ʵΪint */


/* ջṹ */
typedef struct StackNode
{
        SElemType data;
        struct StackNode *next;
}StackNode,*LinkStackPtr;


typedef struct
{
        LinkStackPtr top;
        int count;
}LinkStack;

Status visit(SElemType c)
{
        printf("%d ",c);
        return OK;
}

/*  һջS */
Status InitStack(LinkStack *S)
{ 
        S->top = (LinkStackPtr)malloc(sizeof(StackNode));
        if(!S->top)
                return ERROR;
        S->top=NULL;
        S->count=0;
        return OK;
}

/* SΪջ */
Status ClearStack(LinkStack *S)
{ 
        LinkStackPtr p,q;
        p=S->top;
        while(p)
        {  
                q=p;
                p=p->next;
                free(q);
        } 
        S->count=0;
        return OK;
}

/* ջSΪջ򷵻TRUE򷵻FALSE */
Status StackEmpty(LinkStack S)
{ 
        if (S.count==0)
                return TRUE;
        else
                return FALSE;
}

/* SԪظջĳ */
int StackLength(LinkStack S)
{ 
        return S.count;
}

/* ջգeSջԪأOK򷵻ERROR */
Status GetTop(LinkStack S,SElemType *e)
{
        if (S.top==NULL)
                return ERROR;
        else
                *e=S.top->data;
        return OK;
}

/* ԪeΪµջԪ */
Status Push(LinkStack *S,SElemType e)
{
        LinkStackPtr s=(LinkStackPtr)malloc(sizeof(StackNode)); 
        s->data=e; 
        s->next=S->top;	/* ѵǰջԪظֵ½ֱӺ̣ͼТ */
        S->top=s;         /* µĽsֵջָ룬ͼТ */
        S->count++;
        return OK;
}

/* ջգɾSջԪأeֵOK򷵻ERROR */
Status Pop(LinkStack *S,SElemType *e)
{ 
        LinkStackPtr p;
        if(StackEmpty(*S))
                return ERROR;
        *e=S->top->data;
        p=S->top;					/* ջ㸳ֵpͼТ */
        S->top=S->top->next;    /* ʹջָһλָһ㣬ͼТ */
        free(p);                    /* ͷŽp */        
        S->count--;
        return OK;
}

Status StackTraverse(LinkStack S)
{
        LinkStackPtr p;
        p=S.top;
        while(p)
        {
                 visit(p->data);
                 p=p->next;
        }
        printf("\n");
        return OK;
}

int main()
{
        int j;
        LinkStack s;
        int e;
        if(InitStack(&s)==OK)
                for(j=1;j<=10;j++)
                        Push(&s,j);
        printf("ջԪΪ");
        StackTraverse(s);
        Pop(&s,&e);
        printf("ջԪ e=%d\n",e);
        printf("ջշ%d(1: 0:)\n",StackEmpty(s));
        GetTop(s,&e);
        printf("ջԪ e=%d ջĳΪ%d\n",e,StackLength(s));
        ClearStack(&s);
        printf("ջջշ%d(1: 0:)\n",StackEmpty(s));
        return 0;
}