#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0
#define MAXSIZE 100 /* 洢ռʼ */

typedef int Status;	/* StatusǺ,ֵǺ״̬룬OK */ 


/* Ķṹ */
typedef  struct BiTNode	/* ṹ */
{
	int data;	/*  */
	int bf; /*  ƽ */ 
	struct BiTNode *lchild, *rchild;	/* Һָ */
} BiTNode, *BiTree;


/* pΪĶ */
/* ֮pָµ㣬ת֮ǰĸ */
void R_Rotate(BiTree *P)
{ 
	BiTree L;
	L=(*P)->lchild; /*  LָP */ 
	(*P)->lchild=L->rchild; /*  LҽΪP */ 
	L->rchild=(*P);
	*P=L; /*  Pָµĸ */ 
}

/* PΪĶ */
/* ֮Pָµ㣬ת֮ǰĸ0  */
void L_Rotate(BiTree *P)
{ 
	BiTree R;
	R=(*P)->rchild; /*  RָP */ 
	(*P)->rchild=R->lchild; /* RҽΪP */ 
	R->lchild=(*P);
	*P=R; /*  Pָµĸ */ 
}

#define LH +1 /*   */ 
#define EH 0  /*  ȸ */ 
#define RH -1 /*  Ҹ */ 

/*  ָTָΪĶƽת */
/*  㷨ʱָTָµĸ */
void LeftBalance(BiTree *T)
{ 
	BiTree L,Lr;
	L=(*T)->lchild; /*  LָT */ 
	switch(L->bf)
	{ /*  TƽȣӦƽ⴦ */ 
		 case LH: /*  ½TӵϣҪ */ 
			(*T)->bf=L->bf=EH;
			R_Rotate(T);
			break;
		 case RH: /*  ½TӵϣҪ˫ */ 
			Lr=L->rchild; /*  LrָTӵ */ 
			switch(Lr->bf)
			{ /*  ޸Tӵƽ */ 
				case LH: (*T)->bf=RH;
						 L->bf=EH;
						 break;
				case EH: (*T)->bf=L->bf=EH;
						 break;
				case RH: (*T)->bf=EH;
						 L->bf=LH;
						 break;
			}
			Lr->bf=EH;
			L_Rotate(&(*T)->lchild); /*  Tƽ⴦ */ 
			R_Rotate(T); /*  Tƽ⴦ */ 
	}
}

/*  ָTָΪĶƽת */ 
/*  㷨ʱָTָµĸ */ 
void RightBalance(BiTree *T)
{ 
	BiTree R,Rl;
	R=(*T)->rchild; /*  RָT */ 
	switch(R->bf)
	{ /*  TƽȣӦƽ⴦ */ 
	 case RH: /*  ½TҺӵϣҪ */ 
			  (*T)->bf=R->bf=EH;
			  L_Rotate(T);
			  break;
	 case LH: /*  ½TҺӵϣҪ˫ */ 
			  Rl=R->lchild; /*  RlָTҺӵ */ 
			  switch(Rl->bf)
			  { /*  ޸TҺӵƽ */ 
				case RH: (*T)->bf=LH;
						 R->bf=EH;
						 break;
				case EH: (*T)->bf=R->bf=EH;
						 break;
				case LH: (*T)->bf=EH;
						 R->bf=RH;
						 break;
			  }
			  Rl->bf=EH;
			  R_Rotate(&(*T)->rchild); /*  Tƽ⴦ */ 
			  L_Rotate(T); /*  Tƽ⴦ */ 
	}
}

/*  ƽĶTвںeͬؼֵĽ㣬һ */ 
/*  ԪΪe½㣬1򷵻0ʹ */ 
/*  ʧȥƽ⣬ƽתtallerӳT */
Status InsertAVL(BiTree *T,int e,Status *taller)
{  
	if(!*T)
	{ /*  ½㣬ߡtallerΪTRUE */ 
		 *T=(BiTree)malloc(sizeof(BiTNode));
		 (*T)->data=e; (*T)->lchild=(*T)->rchild=NULL; (*T)->bf=EH;
		 *taller=TRUE;
	}
	else
	{
		if (e==(*T)->data)
		{ /*  ѴںeͬؼֵĽٲ */ 
			*taller=FALSE; return FALSE;
		}
		if (e<(*T)->data)
		{ /*  ӦTн */ 
			if(!InsertAVL(&(*T)->lchild,e,taller)) /*  δ */ 
				return FALSE;
			if(*taller) /*   Ѳ뵽Tߡ */ 
				switch((*T)->bf) /*  Tƽ */ 
				{
					case LH: /*  ԭߣҪƽ⴦ */ 
							LeftBalance(T);	*taller=FALSE; break;
					case EH: /*  ԭȸߣ߶ʹ */ 
							(*T)->bf=LH; *taller=TRUE; break;
					case RH: /*  ԭߣȸ */  
							(*T)->bf=EH; *taller=FALSE; break;
				}
		}
		else
		{ /*  ӦTн */ 
			if(!InsertAVL(&(*T)->rchild,e,taller)) /*  δ */ 
				return FALSE;
			if(*taller) /*  Ѳ뵽Tߡ */ 
				switch((*T)->bf) /*  Tƽ */ 
				{
					case LH: /*  ԭߣȸ */ 
							(*T)->bf=EH; *taller=FALSE;	break;
					case EH: /*  ԭȸߣ߶ʹ  */
							(*T)->bf=RH; *taller=TRUE; break;
					case RH: /*  ԭߣҪƽ⴦ */ 
							RightBalance(T); *taller=FALSE; break;
				}
		}
	}
	return TRUE;
}

int main(void)
{    
	int i;
	int a[10]={3,2,1,4,5,6,7,10,9,8};
	BiTree T=NULL;
	Status taller;
	for(i=0;i<10;i++)
	{
		InsertAVL(&T,a[i],&taller);
	}
	printf("ϵٲ鿴ƽṹ");
	return 0;
}