#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0
#define MAXSIZE 20 /* 洢ռʼ */

typedef int Status; 
typedef int QElemType; /* QElemType͸ʵΪint */

/* ѭе˳洢ṹ */
typedef struct
{
	QElemType data[MAXSIZE];
	int front;    	/* ͷָ */
	int rear;		/* βָ룬вգָβԪصһλ */
}SqQueue;

Status visit(QElemType c)
{
	printf("%d ",c);
	return OK;
}

/* ʼһնQ */
Status InitQueue(SqQueue *Q)
{
	Q->front=0;
	Q->rear=0;
	return  OK;
}

/* QΪն */
Status ClearQueue(SqQueue *Q)
{
	Q->front=Q->rear=0;
	return OK;
}

/* QΪն,򷵻TRUE,򷵻FALSE */
Status QueueEmpty(SqQueue Q)
{ 
	if(Q.front==Q.rear) /* пյı־ */
		return TRUE;
	else
		return FALSE;
}

/* QԪظҲǶеĵǰ */
int QueueLength(SqQueue Q)
{
	return  (Q.rear-Q.front+MAXSIZE)%MAXSIZE;
}

/* в,eQĶͷԪ,OK,򷵻ERROR */
Status GetHead(SqQueue Q,QElemType *e)
{
	if(Q.front==Q.rear) /* п */
		return ERROR;
	*e=Q.data[Q.front];
	return OK;
}

/* δԪeΪQµĶβԪ */
Status EnQueue(SqQueue *Q,QElemType e)
{
	if ((Q->rear+1)%MAXSIZE == Q->front)	/* ж */
		return ERROR;
	Q->data[Q->rear]=e;			/* Ԫeֵβ */
	Q->rear=(Q->rear+1)%MAXSIZE;/* rearָһλã */
								/* תͷ */
	return  OK;
}

/* вգɾQжͷԪأeֵ */
Status DeQueue(SqQueue *Q,QElemType *e)
{
	if (Q->front == Q->rear)			/* пյж */
		return ERROR;
	*e=Q->data[Q->front];				/* ͷԪظֵe */
	Q->front=(Q->front+1)%MAXSIZE;	/* frontָһλã */
									/* תͷ */
	return  OK;
}

/* ӶͷβζԶQÿԪ */
Status QueueTraverse(SqQueue Q)
{ 
	int i;
	i=Q.front;
	while((i+Q.front)!=Q.rear)
	{
		visit(Q.data[i]);
		i=(i+1)%MAXSIZE;
	}
	printf("\n");
	return OK;
}

int main()
{
	Status j;
	int i=0,l;
	QElemType d;
	SqQueue Q;
	InitQueue(&Q);
	printf("ʼк󣬶пշ%u(1: 0:)\n",QueueEmpty(Q));

	printf("ͶԪ(%d),-1Ϊǰ: ",MAXSIZE-1);
	do
	{
		/* scanf("%d",&d); */
		d=i+100;
		if(d==-1)
			break;
		i++;
		EnQueue(&Q,d);
	}while(i<MAXSIZE-1);

	printf("гΪ: %d\n",QueueLength(Q));
	printf("ڶпշ%u(1: 0:)\n",QueueEmpty(Q));
	printf("%dɶͷɾԪ,βԪ:\n",MAXSIZE);
	for(l=1;l<=MAXSIZE;l++)
	{
		DeQueue(&Q,&d);
		printf("ɾԪ%d,Ԫ:%d \n",d,l+1000);
		/* scanf("%d",&d); */
		d=l+1000;
		EnQueue(&Q,d);
	}
	l=QueueLength(Q);

	printf("ڶеԪΪ: \n");
	QueueTraverse(Q);
	printf("β%dԪ\n",i+MAXSIZE);
	if(l-2>0)
		printf("ɶͷɾ%dԪ:\n",l-2);
	while(QueueLength(Q)>2)
	{
		DeQueue(&Q,&d);
		printf("ɾԪֵΪ%d\n",d);
	}

	j=GetHead(Q,&d);
	if(j)
		printf("ڶͷԪΪ: %d\n",d);
	ClearQueue(&Q);
	printf("նк, пշ%u(1: 0:)\n",QueueEmpty(Q));
	return 0;
}

