#include "string.h"
#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAXSIZE 40 /* 洢ռʼ */

typedef int Status;		/* StatusǺ,ֵǺ״̬룬OK */
typedef int ElemType;	/* ElemType͸ʵΪint */

typedef char String[MAXSIZE+1]; /*  0ŵԪŴĳ */

/* һֵcharsĴT */
Status StrAssign(String T,char *chars)
{ 
	int i;
	if(strlen(chars)>MAXSIZE)
		return ERROR;
	else
	{
		T[0]=strlen(chars);
		for(i=1;i<=T[0];i++)
			T[i]=*(chars+i-1);
		return OK;
	}
}

/* ɴSƵôT */
Status StrCopy(String T,String S)
{ 
	int i;
	for(i=0;i<=S[0];i++)
		T[i]=S[i];
	return OK;
}

/* SΪմ,򷵻TRUE,򷵻FALSE */
Status StrEmpty(String S)
{ 
	if(S[0]==0)
		return TRUE;
	else
		return FALSE;
}

/*  ʼ: ST */
/*  : S>T,򷵻ֵ>0;S=T,򷵻ֵ=0;S<T,򷵻ֵ<0 */
int StrCompare(String S,String T)
{ 
	int i;
	for(i=1;i<=S[0]&&i<=T[0];++i)
		if(S[i]!=T[i])
			return S[i]-T[i];
	return S[0]-T[0];
}

/* شԪظ */
int StrLength(String S)
{ 
	return S[0];
}

/* ʼ:Sڡ:SΪմ */
Status ClearString(String S)
{ 
	S[0]=0;/*  Ϊ */
	return OK;
}

/* TS1S2Ӷɵ´δضϣ򷵻TRUEFALSE */
Status Concat(String T,String S1,String S2)
{
	int i;
	if(S1[0]+S2[0]<=MAXSIZE)
	{ /*  δض */
		for(i=1;i<=S1[0];i++)
			T[i]=S1[i];
		for(i=1;i<=S2[0];i++)
			T[S1[0]+i]=S2[i];
		T[0]=S1[0]+S2[0];
		return TRUE;
	}
	else
	{ /*  ضS2 */
		for(i=1;i<=S1[0];i++)
			T[i]=S1[i];
		for(i=1;i<=MAXSIZE-S1[0];i++)
			T[S1[0]+i]=S2[i];
		T[0]=MAXSIZE;
		return FALSE;
	}
}

/* SubشSĵposַ𳤶ΪlenӴ */
Status SubString(String Sub,String S,int pos,int len)
{
	int i;
	if(pos<1||pos>S[0]||len<0||len>S[0]-pos+1)
		return ERROR;
	for(i=1;i<=len;i++)
		Sub[i]=S[pos+i-1];
	Sub[0]=len;
	return OK;
}

/* ӴTSеposַ֮λá,ֵΪ0 */
/* ,Tǿ,1posStrLength(S) */
int Index(String S, String T, int pos) 
{
	int i = pos;	/* iSеǰλ±ֵposΪ1posλÿʼƥ */
	int j = 1;				/* jӴTеǰλ±ֵ */
	while (i <= S[0] && j <= T[0]) /* iСSĳȲjСTĳʱѭ */
	{
		if (S[i] == T[j]) 	/* ĸ */
      	{
			++i;
         	++j; 
      	} 
      	else 				/* ָ¿ʼƥ */
      	{  
         	i = i-j+2;		/* i˻صϴƥλһλ */
         	j = 1; 			/* j˻صӴTλ */
      	}      
	}
	if (j > T[0]) 
		return i-T[0];
	else 
		return 0;
}


/*  TΪǿմSеposַ֮TȵӴ */
/*  򷵻صһӴSеλã򷵻0 */
int Index2(String S, String T, int pos) 
{
	int n,m,i;
	String sub;
	if (pos > 0) 
	{
		n = StrLength(S);	/* õSĳ */
		m = StrLength(T);	/* õӴTĳ */
		i = pos;
		while (i <= n-m+1) 
		{
			SubString (sub, S, i, m);	/* ȡеiλóTȵӴsub */
			if (StrCompare(sub,T) != 0)    /*  */
				++i;
			else 				/*  */
				return i;		/* 򷵻iֵ */
		}
	}
	return 0;	/* ӴTȣ0 */
}


/*  ʼ: ST,1posStrLength(S)+1 */
/*  : ڴSĵposַ֮ǰ봮Tȫ뷵TRUE,ֲ뷵FALSE */
Status StrInsert(String S,int pos,String T)
{ 
	int i;
	if(pos<1||pos>S[0]+1)
		return ERROR;
	if(S[0]+T[0]<=MAXSIZE)
	{ /*  ȫ */
		for(i=S[0];i>=pos;i--)
			S[i+T[0]]=S[i];
		for(i=pos;i<pos+T[0];i++)
			S[i]=T[i-pos+1];
		S[0]=S[0]+T[0];
		return TRUE;
	}
	else
	{ /*  ֲ */
		for(i=MAXSIZE;i<=pos;i--)
			S[i]=S[i-T[0]];
		for(i=pos;i<pos+T[0];i++)
			S[i]=T[i-pos+1];
		S[0]=MAXSIZE;
		return FALSE;
	}
}

/*  ʼ: S,1posStrLength(S)-len+1 */
/*  : ӴSɾposַ𳤶ΪlenӴ */
Status StrDelete(String S,int pos,int len)
{ 
	int i;
	if(pos<1||pos>S[0]-len+1||len<0)
		return ERROR;
	for(i=pos+len;i<=S[0];i++)
		S[i-len]=S[i];
	S[0]-=len;
	return OK;
}

/*  ʼ: S,TV,TǷǿմ˺봮Ĵ洢ṹ޹أ */
/*  : V滻SгֵTȵĲصӴ */
Status Replace(String S,String T,String V)
{ 
	int i=1; /*  ӴSĵһַҴT */
	if(StrEmpty(T)) /*  Tǿմ */
		return ERROR;
	do
	{
		i=Index(S,T,i); /*  iΪһi֮ҵӴTλ */
		if(i) /*  SдڴT */
		{
			StrDelete(S,i,StrLength(T)); /*  ɾôT */
			StrInsert(S,i,V); /*  ԭTλò봮V */
			i+=StrLength(V); /*  ڲĴVҴT */
		}
	}while(i);
	return OK;
}

/*  ַT */
void StrPrint(String T)
{ 
	int i;
	for(i=1;i<=T[0];i++)
		printf("%c",T[i]);
	printf("\n");
}


int main()
{
	
	int i,j;
	Status k;
	char s;
	String t,s1,s2;
	printf("봮s1: ");
	
	k=StrAssign(s1,"abcd");
	if(!k)
	{
		printf("MAXSIZE(=%d)\n",MAXSIZE);
		exit(0);
	}
	printf("Ϊ%d շ%d(1: 0:)\n",StrLength(s1),StrEmpty(s1));
	StrCopy(s2,s1);
	printf("s1ɵĴΪ: ");
	StrPrint(s2);
	printf("봮s2: ");
	
	k=StrAssign(s2,"efghijk");
	if(!k)
	{
		printf("MAXSIZE(%d)\n",MAXSIZE);
		exit(0);
	}
	i=StrCompare(s1,s2);
	if(i<0)
		s='<';
	else if(i==0)
		s='=';
	else
		s='>';
	printf("s1%cs2\n",s);
	k=Concat(t,s1,s2);
	printf("s1Ӵs2õĴtΪ: ");
	StrPrint(t);
	if(k==FALSE)
		printf("tнض\n");
	ClearString(s1);
	printf("Ϊմ,s1Ϊ: ");
	StrPrint(s1);
	printf("Ϊ%d շ%d(1: 0:)\n",StrLength(s1),StrEmpty(s1));
	printf("tӴ,Ӵʼλ,Ӵ: ");

	i=2;
	j=3;
	printf("%d,%d \n",i,j);

	k=SubString(s2,t,i,j);
	if(k)
	{
		printf("Ӵs2Ϊ: ");
		StrPrint(s2);
	}
	printf("Ӵtĵposַ,ɾlenַpos,len: ");
	
	i=4;
	j=2;
	printf("%d,%d \n",i,j);


	StrDelete(t,i,j);
	printf("ɾĴtΪ: ");
	StrPrint(t);
	i=StrLength(s2)/2;
	StrInsert(s2,i,t);
	printf("ڴs2ĵ%dַ֮ǰ봮t,s2Ϊ:\n",i);
	StrPrint(s2);
	i=Index(s2,t,1);
	printf("s2ĵ%dĸtһƥ\n",i);
	SubString(t,s2,1,1);
	printf("tΪ");
	StrPrint(t);
	Concat(s1,t,t);
	printf("s1Ϊ");
	StrPrint(s1);
	Replace(s2,t,s1);
	printf("ôs1ȡs2кʹtͬĲصĴ,s2Ϊ: ");
	StrPrint(s2);


	return 0;
}

