#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0
#define MAXVEX 100 /* 󶥵,Ӧû */

typedef int Status;	/* StatusǺ,ֵǺ״̬,OK */
typedef char VertexType; /* Ӧû */
typedef int EdgeType; /* ϵȨֵӦû */

typedef struct EdgeNode /* ߱  */
{
	int adjvex;    /* ڽӵ,洢öӦ± */
	EdgeType info;		/* ڴ洢Ȩֵ,ڷͼԲҪ */
	struct EdgeNode *next; /* ,ָһڽӵ */
}EdgeNode;

typedef struct VertexNode /*  */
{
	VertexType data; /* ,洢Ϣ */
	EdgeNode *firstedge;/* ߱ͷָ */
}VertexNode, AdjList[MAXVEX];

typedef struct
{
	AdjList adjList; 
	int numNodes,numEdges; /* ͼеǰͱ */
}GraphAdjList;

/* ͼڽӱṹ */
void  CreateALGraph(GraphAdjList *G)
{
	int i,j,k;
	EdgeNode *e;
	printf("붥ͱ:\n");
	scanf("%d,%d",&G->numNodes,&G->numEdges); /* 붥ͱ */
	for(i = 0;i < G->numNodes;i++) /* 붥Ϣ, */
	{
		scanf(&G->adjList[i].data); 	/* 붥Ϣ */
		G->adjList[i].firstedge=NULL; 	/* ߱Ϊձ */
	}
	
	
	for(k = 0;k < G->numEdges;k++)/* ߱ */
	{
		printf("(vi,vj)ϵĶ:\n");
		scanf("%d,%d",&i,&j); /* (vi,vj)ϵĶ */
		e=(EdgeNode *)malloc(sizeof(EdgeNode)); /* ڴռ,ɱ߱ */
		e->adjvex=j;					/* ڽΪj */                         
		e->next=G->adjList[i].firstedge;	/* eָָǰָĽ */
		G->adjList[i].firstedge=e;		/* ǰָָe */               
		
		e=(EdgeNode *)malloc(sizeof(EdgeNode)); /* ڴռ,ɱ߱ */
		e->adjvex=i;					/* ڽΪi */                         
		e->next=G->adjList[j].firstedge;	/* eָָǰָĽ */
		G->adjList[j].firstedge=e;		/* ǰָָe */               
	}
}

int main(void)
{    
	GraphAdjList G;    
	CreateALGraph(&G);
	
	return 0;
}

