#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAXSIZE 100 /* 洢ռʼ */

#define SUCCESS 1
#define UNSUCCESS 0
#define HASHSIZE 12 /* ɢбΪĳ */
#define NULLKEY -32768 

typedef int Status;	/* StatusǺ,ֵǺ״̬룬OK */ 

typedef struct
{
   int *elem; /* Ԫش洢ַ̬ */
   int count; /*  ǰԪظ */
}HashTable;

int m=0; /* ɢбȫֱ */

/* ʼɢб */
Status InitHashTable(HashTable *H)
{
	int i;
	m=HASHSIZE;
	H->count=m;
	H->elem=(int *)malloc(m*sizeof(int));
	for(i=0;i<m;i++)
		H->elem[i]=NULLKEY; 
	return OK;
}

/* ɢк */
int Hash(int key)
{
	return key % m; /*  */
}

/* ؼֽɢб */
void InsertHash(HashTable *H,int key)
{
	int addr = Hash(key); /* ɢеַ */
	while (H->elem[addr] != NULLKEY) /* Ϊգͻ */
	{
		addr = (addr+1) % m; /* Ŷַ̽ */
	}
	H->elem[addr] = key; /* ֱпλؼ */
}

/* ɢбҹؼ */
Status SearchHash(HashTable H,int key,int *addr)
{
	*addr = Hash(key);  /* ɢеַ */
	while(H.elem[*addr] != key) /* Ϊգͻ */
	{
		*addr = (*addr+1) % m; /* Ŷַ̽ */
		if (H.elem[*addr] == NULLKEY || *addr == Hash(key)) /* ѭصԭ */
			return UNSUCCESS;	/* ˵ؼֲ */
	}
	return SUCCESS;
}

int main()
{
	int arr[HASHSIZE]={12,67,56,16,25,37,22,29,15,47,48,34};
	int i,p,key,result;
	HashTable H;

	key=39;

	InitHashTable(&H);
	for(i=0;i<m;i++)
		 InsertHash(&H,arr[i]);
	
	result=SearchHash(H,key,&p);
	if (result)
		printf(" %d ĵַΪ%d \n",key,p);
	else
		printf(" %d ʧܡ\n",key);

	for(i=0;i<m;i++)
	{
		key=arr[i];
		SearchHash(H,key,&p);
		printf(" %d ĵַΪ%d \n",key,p);
	}

	return 0;
}
