#include <stdio.h>    
#include <string.h>
#include <ctype.h>      
#include <stdlib.h>   
#include <io.h>  
#include <math.h>  
#include <time.h>

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAX_LENGTH_INSERT_SORT 7 /* ڿʱжǷѡòֵ */

typedef int Status; 


#define MAXSIZE 10000  /* ҪֵɸҪ޸ */
typedef struct
{
	int r[MAXSIZE+1];	/* ڴ洢Ҫ飬r[0]ڱʱ */
	int length;			/* ڼ¼˳ĳ */
}SqList;

/* Lr±Ϊijֵ */
void swap(SqList *L,int i,int j) 
{ 
	int temp=L->r[i]; 
	L->r[i]=L->r[j]; 
	L->r[j]=temp; 
}

void print(SqList L)
{
	int i;
	for(i=1;i<L.length;i++)
		printf("%d,",L.r[i]);
	printf("%d",L.r[i]);
	printf("\n");
}

/* ˳Lð棩 */
void BubbleSort0(SqList *L)
{ 
	int i,j;
	for(i=1;i<L->length;i++)
	{
		for(j=i+1;j<=L->length;j++)
		{
			if(L->r[i]>L->r[j])
			{
				 swap(L,i,j);/* L->r[i]L->r[j]ֵ */
			}
		}
	}
}

/* ˳Lð */
void BubbleSort(SqList *L)
{ 
	int i,j;
	for(i=1;i<L->length;i++)
	{
		for(j=L->length-1;j>=i;j--)  /* עjǴӺǰѭ */
		{
			if(L->r[j]>L->r[j+1]) /* ǰߴںߣעһ㷨Ĳ죩*/
			{
				 swap(L,j,j+1);/* L->r[j]L->r[j+1]ֵ */
			}
		}
	}
}

/* ˳LĽð㷨 */
void BubbleSort2(SqList *L)
{ 
	int i,j;
	Status flag=TRUE;			/* flagΪ */
	for(i=1;i<L->length && flag;i++) /* flagΪtrue˵йݽֹͣѭ */
	{
		flag=FALSE;				/* ʼΪFalse */
		for(j=L->length-1;j>=i;j--)
		{
			if(L->r[j]>L->r[j+1])
			{
				 swap(L,j,j+1);	/* L->r[j]L->r[j+1]ֵ */
				 flag=TRUE;		/* ݽflagΪtrue */
			}
		}
	}
}


/* ˳Lѡ */
void SelectSort(SqList *L)
{
	int i,j,min;
	for(i=1;i<L->length;i++)
	{ 
		min = i;						/* ǰ±궨ΪСֵ± */
		for (j = i+1;j<=L->length;j++)/* ѭ֮ */
        {
			if (L->r[min]>L->r[j])	/* СڵǰСֵĹؼ */
                min = j;				/* ˹ؼֵ±긳ֵmin */
        }
		if(i!=min)						/* mini˵ҵСֵ */
			swap(L,i,min);				/* L->r[i]L->r[min]ֵ */
	}
}

/* ˳LֱӲ */
void InsertSort(SqList *L)
{ 
	int i,j;
	for(i=2;i<=L->length;i++)
	{
		if (L->r[i]<L->r[i-1]) /* 轫L->r[i]ӱ */
		{
			L->r[0]=L->r[i]; /* ڱ */
			for(j=i-1;L->r[j]>L->r[0];j--)
				L->r[j+1]=L->r[j]; /* ¼ */
			L->r[j+1]=L->r[0]; /* 뵽ȷλ */
		}
	}
}

/* ˳Lϣ */
void ShellSort(SqList *L)
{
	int i,j,k=0;
	int increment=L->length;
	do
	{
		increment=increment/3+1;/*  */
		for(i=increment+1;i<=L->length;i++)
		{
			if (L->r[i]<L->r[i-increment])/*  轫L->r[i]ӱ */ 
			{ 
				L->r[0]=L->r[i]; /*  ݴL->r[0] */
				for(j=i-increment;j>0 && L->r[0]<L->r[j];j-=increment)
					L->r[j+increment]=L->r[j]; /*  ¼ƣҲλ */
				L->r[j+increment]=L->r[0]; /*   */
			}
		}
		printf("	%d: ",++k);
		print(*L);
	}
	while(increment>1);

}


/* ********************************** */

/* ֪L->r[s..m]м¼ĹؼֳL->r[s]֮ѵĶ壬 */
/* L->r[s]Ĺؼ,ʹL->r[s..m]Ϊһ󶥶 */
void HeapAdjust(SqList *L,int s,int m)
{ 
	int temp,j;
	temp=L->r[s];
	for(j=2*s;j<=m;j*=2) /* عؼֽϴĺӽɸѡ */
	{
		if(j<m && L->r[j]<L->r[j+1])
			++j; /* jΪؼнϴļ¼± */
		if(temp>=L->r[j])
			break; /* rcӦλs */
		L->r[s]=L->r[j];
		s=j;
	}
	L->r[s]=temp; /*  */
}

/*  ˳Lж */
void HeapSort(SqList *L)
{
	int i;
	for(i=L->length/2;i>0;i--) /*  Lеrһ */
		 HeapAdjust(L,i,L->length);

	for(i=L->length;i>1;i--)
	{ 
		 swap(L,1,i); /* Ѷ¼͵ǰδеһ¼ */
		 HeapAdjust(L,1,i-1); /*  L->r[1..i-1]µΪ */
	}
}

/* **************************************** */


/* 鲢********************************** */

/* SR[i..m]SR[m+1..n]鲢ΪTR[i..n] */
void Merge(int SR[],int TR[],int i,int m,int n)
{
	int j,k,l;
	for(j=m+1,k=i;i<=m && j<=n;k++)	/* SRм¼СزTR */
	{
		if (SR[i]<SR[j])
			TR[k]=SR[i++];
		else
			TR[k]=SR[j++];
	}
	if(i<=m)
	{
		for(l=0;l<=m-i;l++)
			TR[k+l]=SR[i+l];		/* ʣSR[i..m]ƵTR */
	}
	if(j<=n)
	{
		for(l=0;l<=n-j;l++)
			TR[k+l]=SR[j+l];		/* ʣSR[j..n]ƵTR */
	}
}


/* ݹ鷨 */
/* SR[s..t]鲢ΪTR1[s..t] */
void MSort(int SR[],int TR1[],int s, int t)
{
	int m;
	int TR2[MAXSIZE+1];
	if(s==t)
		TR1[s]=SR[s];
	else
	{
		m=(s+t)/2;				/* SR[s..t]ƽΪSR[s..m]SR[m+1..t] */
		MSort(SR,TR2,s,m);		/* ݹؽSR[s..m]鲢ΪTR2[s..m] */
		MSort(SR,TR2,m+1,t);	/* ݹؽSR[m+1..t]鲢ΪTR2[m+1..t] */
		Merge(TR2,TR1,s,m,t);	/* TR2[s..m]TR2[m+1..t]鲢TR1[s..t] */
	}
}

/* ˳L鲢 */
void MergeSort(SqList *L)
{ 
 	MSort(L->r,L->r,1,L->length);
}

/* ǵݹ鷨 */
/* SR[]ڳΪs鲢TR[] */
void MergePass(int SR[],int TR[],int s,int n)
{
	int i=1;
	int j;
	while(i <= n-2*s+1)
	{/* 鲢 */
		Merge(SR,TR,i,i+s-1,i+2*s-1);
		i=i+2*s;        
	}
	if(i<n-s+1) /* 鲢 */
		Merge(SR,TR,i,i+s-1,n);
	else /* ֻʣµ */
		for(j =i;j <= n;j++)
			TR[j] = SR[j];
}

/* ˳L鲢ǵݹ */
void MergeSort2(SqList *L)
{
	int* TR=(int*)malloc(L->length * sizeof(int));/* ռ */
    int k=1;
	while(k<L->length)
	{
		MergePass(L->r,TR,k,L->length);
		k=2*k;/* гȼӱ */
		MergePass(TR,L->r,k,L->length);
		k=2*k;/* гȼӱ */       
	}
}

/* **************************************** */

/* ******************************** */
 
/* ˳Lӱļ¼ʹ¼λλ */
/* ʱ֮ǰ()ļ¼(С) */
int Partition(SqList *L,int low,int high)
{ 
	int pivotkey;

	pivotkey=L->r[low]; /* ӱĵһ¼¼ */
	while(low<high) /*  ӱ˽мɨ */
	{ 
		 while(low<high&&L->r[high]>=pivotkey)
			high--;
		 swap(L,low,high);/* ¼Сļ¼Ͷ */
		 while(low<high&&L->r[low]<=pivotkey)
			low++;
		 swap(L,low,high);/* ¼ļ¼߶ */
	}
	return low; /* λ */
}

/* ˳LеL->r[low..high] */
void QSort(SqList *L,int low,int high)
{ 
	int pivot;
	if(low<high)
	{
			pivot=Partition(L,low,high); /*  L->r[low..high]һΪֵpivot */
			QSort(L,low,pivot-1);		/*  Եӱݹ */
			QSort(L,pivot+1,high);		/*  Ըӱݹ */
	}
}

/* ˳L */
void QuickSort(SqList *L)
{ 
	QSort(L,1,L->length);
}

/* **************************************** */

/* Ľ******************************** */

/* Ż㷨 */
int Partition1(SqList *L,int low,int high)
{ 
	int pivotkey;

	int m = low + (high - low) / 2; /* мԪص± */  
	if (L->r[low]>L->r[high])			
		swap(L,low,high);	/* Ҷݣ֤˽С */
	if (L->r[m]>L->r[high])
		swap(L,high,m);		/* мҶݣ֤мС */
	if (L->r[m]>L->r[low])
		swap(L,m,low);		/* мݣ֤˽С */
	
	pivotkey=L->r[low]; /* ӱĵһ¼¼ */
	L->r[0]=pivotkey;  /* ؼֱݵL->r[0] */
	while(low<high) /*  ӱ˽мɨ */
	{ 
		 while(low<high&&L->r[high]>=pivotkey)
			high--;
		 L->r[low]=L->r[high];
		 while(low<high&&L->r[low]<=pivotkey)
			low++;
		 L->r[high]=L->r[low];
	}
	L->r[low]=L->r[0];
	return low; /* λ */
}

void QSort1(SqList *L,int low,int high)
{ 
	int pivot;
	if((high-low)>MAX_LENGTH_INSERT_SORT)
	{
		while(low<high)
		{
			pivot=Partition1(L,low,high); /*  L->r[low..high]һΪֵpivot */
			QSort1(L,low,pivot-1);		/*  Եӱݹ */
			/* QSort(L,pivot+1,high);		/*  Ըӱݹ */
			low=pivot+1;	/* βݹ */
		}
	}
	else
		InsertSort(L);
}

/* ˳L */
void QuickSort1(SqList *L)
{ 
	QSort1(L,1,L->length);
}

/* **************************************** */
#define N 9
int main()
{
   int i;
   
   /* int d[N]={9,1,5,8,3,7,4,6,2}; */
   int d[N]={50,10,90,30,70,40,80,60,20};
   /* int d[N]={9,8,7,6,5,4,3,2,1}; */

   SqList l0,l1,l2,l3,l4,l5,l6,l7,l8,l9,l10;
   
   for(i=0;i<N;i++)
     l0.r[i+1]=d[i];
   l0.length=N;
   l1=l2=l3=l4=l5=l6=l7=l8=l9=l10=l0;
   printf("ǰ:\n");
   print(l0);

   printf("ð:\n");
   BubbleSort0(&l0);
   print(l0);
   
   printf("ð:\n");
   BubbleSort(&l1);
   print(l1);
   
   printf("Ľð:\n");
   BubbleSort2(&l2);
   print(l2);
   
   printf("ѡ:\n");
   SelectSort(&l3);
   print(l3);
   
   printf("ֱӲ:\n");
   InsertSort(&l4);
   print(l4);

   printf("ϣ:\n");
   ShellSort(&l5);
   print(l5);
	
   printf(":\n");
   HeapSort(&l6);
   print(l6);

   printf("鲢򣨵ݹ飩:\n");
   MergeSort(&l7);
   print(l7);

   printf("鲢򣨷ǵݹ飩:\n");
   MergeSort2(&l8);
   print(l8);

   printf(":\n");
   QuickSort(&l9);
   print(l9);

   printf("Ľ:\n");
   QuickSort1(&l10);
   print(l10);


    /**/
	/* 
	srand(time(0));  
	int Max=10000;
	int d[10000];
	int i;
	SqList l0;
	for(i=0;i<Max;i++)
		d[i]=rand()%Max+1;
	for(i=0;i<Max;i++)
		l0.r[i+1]=d[i];
	l0.length=Max;
	MergeSort(l0);
	print(l0);
	*/
	return 0;
}
